package query

import (
	"encoding/json"

	"github.com/binance-chain/go-sdk/common/types"
)

// GetTokens returns list of tokens
func (c *client) GetTokens() ([]types.Token, error) {
	qp := map[string]string{}
	resp, err := c.baseClient.Get("/tokens", qp)
	if err != nil {
		return nil, err
	}

	var tokens []types.Token
	if err := json.Unmarshal(resp, &tokens); err != nil {
		return nil, err
	}

	return tokens, nil
}
